%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Ori_vector = Get_Plate_Orientation(Fastener_Index, Layer)

global ErrCode;

global DB_FASTENERS;

Ori_vector = [];

Method = 'WEIGHTED'; % AVERAGE | WEIGHTED

switch DB_FASTENERS{Fastener_Index}.Joint_topology{Layer}

    case 'plate'
                
        Ori_vector = zeros(3,1);
        
        N_Elements = size(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list,1);
        
        for j=1:N_Elements
            
            Current_Ori_vector = Get_Shell_Orientation_Vector(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list(j));
            
            switch Method
                case 'AVERAGE'
                    Weight = 1/N_Elements;
                case 'WEIGHTED'
                    Weight = Shell_Element_Weight(Fastener_Index, Layer, DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list(j));
                    if (ErrCode < 0)
                        return;
                    end
            end
            
            Ori_vector = Ori_vector + Current_Ori_vector*Weight;
            
        end
        
        Ori_vector = Ori_vector / norm(Ori_vector);
        
    case 'plate_rbe2_sequential'
        
        Ori_vector = zeros(3,1);
        
        [Test_Result, Center_Node_ID] = Plate_RBE2_Seq_Centered_Test(Fastener_Index, Layer); %#ok<ASGLU>
        
        if (ErrCode < 0)
            return;
        end
        
        Elm_list = DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list;
        
        N_Elements = size(Elm_list,1);
        
        for j=1:N_Elements
            
            Current_Ori_vector = Get_Shell_Orientation_Vector(Elm_list(j));
            
            if (Test_Result == 1)
            
                switch Method
                    case 'AVERAGE'
                        Weight = 1/N_Elements;
                    case 'WEIGHTED'
                        Weight = Shell_Element_Weight(Fastener_Index, Layer, Elm_list(j));
                        if (ErrCode < 0)
                            return;
                        end
                end
                
            else
                
                Weight = 1/N_Elements;
            
            end
            
            Ori_vector = Ori_vector + Current_Ori_vector*Weight;
            
        end
        
        Ori_vector = Ori_vector / norm(Ori_vector);
        
    case 'plate_rbe2_parallel'
        
        Ori_vector = zeros(3,1);
                
        Elm_list = DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list;
        
        N_Elements = size(Elm_list,1);
        
        for j=1:N_Elements
            
            Current_Ori_vector = Get_Shell_Orientation_Vector(Elm_list(j));
            
            switch Method
                case 'AVERAGE'
                    Weight = 1/N_Elements;
                case 'WEIGHTED'
                    Weight = Shell_Element_Weight(Fastener_Index, Layer, Elm_list(j));
                    if (ErrCode < 0)
                        return;
                    end
            end
            
            Ori_vector = Ori_vector + Current_Ori_vector*Weight;
            
        end
        
        Ori_vector = Ori_vector / norm(Ori_vector);
        
    case {'rbe2_2d_hole', 'bar_spider_2d_hole'}
        
        Ori_vector = zeros(3,1);
        
        N_Elements = size(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list,1);
        
        Weight = 1/N_Elements;
        
        for j=1:N_Elements
            
            Current_Ori_vector = Get_Shell_Orientation_Vector(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list(j));
            Ori_vector = Ori_vector + Current_Ori_vector*Weight;
            
        end
        
        Ori_vector = Ori_vector / norm(Ori_vector);

    case {'rbe2_3d_hole', 'bar_spider_3d_hole'}

        fprintf (1, '\nОшибка функции Get_Plate_Orientation: аргументы функции ссылаются на неправильный тип присоединенной топологии [%s] !\n', DB_FASTENERS{Fastener_Index}.Joint_topology{Layer});
        ErrCode = -1;
        return;

    otherwise

        fprintf (1, '\nОшибка функции Get_Plate_Orientation: неизвестный тип присоединенной топологии [%s] в болте %i !\n', DB_FASTENERS{Fastener_Index}.Joint_topology{Layer}, Fastener_Index);
        ErrCode = -1;
        return;

end
